#Program for simulating a not necessarily realistic data set for use in insurance.
#Author: Marcos Marin-Galiano
#You have to carry out the functions age.struct and demo.struct in advance to use this program (cf. example).

simul.car<-function(n=1000,ag=age.struct,de=demo.struct)
{
    age<-17:90
    demographic<-c((2:9)*10,(1:10)*100,2000,3000,4000,5000,7000)
    randa<-c(rep(0,73),1)
    randd<-c(rep(0,22),1)
    datmat<-matrix(0,nrow=n,ncol=3)
    dimnames(datmat)[2]<-list(c("Age","Demo","Claim"))
    for (i in 1:n)
    {
    datmat[i,1]<-sum(age*sample(randa))
    datmat[i,2]<-sum(demographic*sample(randd))
    proba<-(ag[ag[,1]==datmat[i,1],2:5]+de[de[,1]==datmat[i,2],2:5])/2
    claimcl<-sample(1:4,1,prob=proba)
    randc<-rep(0,4)
    randc[claimcl]<-1
    randclaim<-c(0,rgamma(1,shape=4.450477,scale=246.4904),rgamma(1,shape=4.589312,scale=905.5823),
    rgamma(1,shape=4.283613,scale=4305.477))
    datmat[i,3]<-sum(randc*randclaim)
    }
    datmat<-as.data.frame(datmat)
    return(datmat)
}
